#include <stdio.h>

#include "config.h"
#include "imapfilter.h"
#include "buffer.h"


/*
 * Initialize buffer.
 */
void
init_buffer(buffer_t * buf)
{
	buf->data = (char *)xmalloc(BUFFER_SIZE + 1);
	*buf->data = '\0';
	buf->size = BUFFER_SIZE + 1;
}


/*
 * Reset buffer.
 */
void
reset_buffer(buffer_t * buf)
{
	*buf->data = '\0';
}


/*
 * Check if the buffer has enough space to store data and reallocate memory if
 * needed.
 */
void
check_buffer(buffer_t * buf, size_t n)
{
	while (n >= buf->size) {
		buf->size += BUFFER_SIZE;
		buf->data = (char *)xrealloc(buf->data, buf->size);
	}
}
